#define kBuffSize 32
extern __IO uint8_t mackey[kBuffSize];
extern __IO uint8_t keyindex;
extern __IO uint8_t key2index;
extern __IO uint8_t keypad;

extern __IO uint16_t mousex;
extern __IO uint16_t mousey;
extern __IO uint16_t mousebits;

#define kPollTimeout 1000000

#define kMacKbdClockPin             GPIO_Pin_1
#define kMacKbdDataPin              GPIO_Pin_0
#define kMacKbdRegister             GPIOD

#define kMSEX1 GPIO_Pin_8
#define kMSEX2 GPIO_Pin_9
#define kMSEY1 GPIO_Pin_10
#define kMSEY2 GPIO_Pin_11
#define kMSESW GPIO_Pin_2

#define kMacKbdStateIdle            0
#define kMacKbdStateReadSettle      1
#define kMacKbdStateReading         2
#define kMacKbdStateWriteSettle     3
#define kMacKbdStateWriting         4
#define kMacKbdStateInquiryWait     5
#define kMacKbdStateTest            6
#define kMacKbdStateInstantWait     7

struct mackbd {
        uint8_t state;
        uint8_t bits;
        uint8_t clockstate;
        uint32_t delay;
        uint8_t cmd;
        uint8_t response;
};

__IO struct mackbd mackbd;

void HandleMacCommand();
void SendMacResponse(uint8_t respbyte);
uint8_t PS2ToMacScancode(uint8_t code, uint8_t keyup, uint8_t extended);

void MacHandler(void);
void MacInit(void);
